<template>
  <div class="status-overview-component">
    <CCard>
      <CCardHeader>
        Status overview
      </CCardHeader>
      <CCardBody>
        <CRow>
          <CCol sm="8">
            <CRow>
              <CCol sm="4" class="mb-4">
                <CCard>
                  <CCardHeader>
                    Drivers On/Off
                  </CCardHeader>
                  <CCardBody>
                    <driver-chart />
                  </CCardBody>
                </CCard>
              </CCol>

              <CCol sm="8" class="mb-4">
                <CCard>
                  <CCardHeader>
                    Active algorithms this month
                  </CCardHeader>
                  <CCardBody>
                    <active-algorithms-chart />
                  </CCardBody>
                </CCard>
              </CCol>
            </CRow>

            <CRow>
              <CCol sm="12" class="mb-4">
                <CCard>
                  <CCardHeader>
                    Location
                  </CCardHeader>
                  <CCardBody>
                    <iframe src="https://www.google.com/maps/embed?pb=!1m14!1m8!1m3!1d1862.0503297219077!2d105.794886!3d21.028658!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x0%3A0x832d1c2b3e67d432!2zROKAmU9mZmljZQ!5e0!3m2!1sen!2s!4v1578569917024!5m2!1sen!2s" allowfullscreen="" style="border:0; width: 100%; height: 300px;" />
                  </CCardBody>
                </CCard>
              </CCol>
            </CRow>
          </CCol>

          <CCol sm="4" class="mb-4">
            <CCard>
              <CCardHeader>
                Temperature
              </CCardHeader>
              <CCardBody>
                <temperature-chart pointed border-color="warning" />
              </CCardBody>
            </CCard>
          </CCol>
        </CRow>

        <CRow>
          <CCol sm="8" class="mb-4">
            <CCard>
              <CCardHeader>
                Log
              </CCardHeader>
              <CCardBody>
                <CDataTable
                  hover
                  :items="logList"
                  :fields="fields"
                  :items-per-page="perPage"
                  :pagination="paginationOptions"
                >
                  <template #logAt="{item}">
                    <td>
                      {{ new Date(item.logAt * 1000) }}
                    </td>
                  </template>

                  <template #impact="{item}">
                    <td>
                      <span :class="`badge badge-${item.impact === 0 ? 'success' : 'warning'}`">
                        {{ item.impact === 0 ? 'GOOD' : 'WARNING' }}
                      </span>
                    </td>
                  </template>
                </CDataTable>
              </CCardBody>
            </CCard>
          </CCol>

          <CCol sm="4" class="mb-4">
            <CCard>
              <CCardHeader>
                Electricity
              </CCardHeader>
              <CCardBody>
                <electricity-chart background-color="danger" />
              </CCardBody>
            </CCard>
          </CCol>
        </CRow>
      </CCardBody>
    </CCard>
  </div>
</template>

<style lang="scss" scoped>
  /* -----------------------------------------------------------
    status-overview-component
    ----------------------------------------------------------- */
  .status-overview-component {
    .card-body {
      .card {
        height: 100%;
        margin-bottom: 30px;
      }
    }
  }
</style>

<script>
import DriverChart from './DriverChart'
import ActiveAlgorithmsChart from './ActiveAlgorithmsChart'
import TemperatureChart from './TemperatureChart'
import ElectricityChart from './ElectricityChart'

export default {
  components: {
    DriverChart,
    ActiveAlgorithmsChart,
    TemperatureChart,
    ElectricityChart
  },

  data () {
    return {
      logList: [
        { id: 1, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 2, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'Overheat', impact: 1 },
        { id: 3, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 4, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 5, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 6, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 7, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 8, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 9, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 10, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 },
        { id: 11, logAt: 1581392366, driver: '1A-1A-1A-1A-1A-1A', message: 'OK', impact: 0 }
      ],
      fields: [
        { key: 'id', label: 'ID', _style: 'width: 50px;' },
        { key: 'logAt', label: 'Date' },
        { key: 'driver', label: 'Driver' },
        { key: 'message', label: 'Message' },
        { key: 'impact', label: 'Impact' }
      ],
      paginationOptions: {
        align: 'center',
        doubleArrows: false,
        previousButtonHtml: 'prev',
        nextButtonHtml: 'next'
      },
      perPage: 5
    }
  }
}
</script>
